﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Xamarin.Forms.Internals;

namespace SfListViewSample
{
    [Preserve(AllMembers = true)]
    #region MessageTemplateSelector
    public class MessageDataTemplateSelector : Xamarin.Forms.DataTemplateSelector
    {
        #region Properties
        public DataTemplate IncomingTextTemplate { get; set; }
        public DataTemplate OutgoingTextTemplate { get; set; }
        public DataTemplate IncomingImageTemplate { get; set; }

        #endregion

        #region Constructor
        public MessageDataTemplateSelector()
        {
            IncomingTextTemplate = new DataTemplate(typeof(IncomingTextTemplate));
            OutgoingTextTemplate = new DataTemplate(typeof(OutgoingTextTemplate));
            IncomingImageTemplate = new DataTemplate(typeof(IncomingImageMessageTemplate));
        }
        #endregion

        #region OnSelectTemplate
        protected override DataTemplate OnSelectTemplate(object item, BindableObject container)
        {
            if (((MessageInfo)item).TemplateType == TemplateType.OutGoingText)
                return OutgoingTextTemplate;
            else if (((MessageInfo)item).TemplateType == TemplateType.IncomingText)
                return IncomingTextTemplate;
            else
                return IncomingImageTemplate;
        }

        #endregion
    }

    #endregion

    #region CustomContentView
    [Preserve(AllMembers = true)]
    public class IncomingCustomContentView : ContentView
    {

    }
    [Preserve(AllMembers = true)]
    public class OutgoingCustomContentView : ContentView
    {

    }

    #endregion
}
